--[[---------------------------------------------------------------------------

Copyright (c) 2008-2017 by K. Scott Piel 
All Rights Reserved

E-mail: < kscottpiel@gmail.com >

This file is part of nUI.

The author no longer develops or directly supports this addon and has released it
into the public domain under the Creative Commons Attribution-NonCommercial 3.0 
Unported license - a copy of which is included in this distribution. This source
may not be distributed without said license.
	   
nUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the enclosed license for more details.
	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS  "AS IS" AND 
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT  LIMITED TO, THE IMPLIED 
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
OF THE POSSIBILITY OF SUCH DAMAGE.

--]]---------------------------------------------------------------------------

if not nUI_Profile then nUI_Profile = {}; end;
nUI_Profile.nUI_ExtraActionBar = {};
local ProfileCounter = nUI_Profile.OverrideActionBar;


local frame = CreateFrame("Frame","nUI_OverrideBarController")

function frame.applyScale(scale)
end

function frame.applyOptions(options)
    frame.options = options
end

function frame.applyAnchor(anchor)

    frame.anchor = anchor or nUI_DefaultConfig.OverrideActionBar.anchor    
    
	local anchor      = anchor or frame.anchor
	local anchor_pt   = anchor.anchor_pt
	local relative_to = anchor.relative_to
	local relative_pt = anchor.relative_pt
	local xOfs        = anchor.xOfs
	local yOfs        = anchor.yOfs
    
    OverrideActionBar:ClearAllPoints()
    OverrideActionBar:SetPoint(anchor_pt,relative_to,relative_pt,xOfs,yOfs)

    hooksecurefunc(OverrideActionBar,"UpdateMicroButtons", function(self)
        ResetMicroMenuPosition()
    end)
end

frame.applySkin = function( skin )    
	local skin = skin and skin.OverrideActionBar or nUI_DefaultConfig.OverrideActionBar;
	if not skin or not skin.enabled then
	else
		frame.applyOptions( skin.options );
		frame.applyAnchor( skin.anchor );
	end
    
    -- Hook into the override bars setup function so that it also setsup the hotkey text
    -- Hopefully this doesn't happen while in combat and triggers an error
    hooksecurefunc(OverrideActionBar,"Setup", function(self,skin, barIndex) 
        for k=1,6 do
            local button = self["SpellButton"..k] 
                
            -- override the hotkey function for this button so that it uses the main nUI action bar hotkeys
            hooksecurefunc(button,"UpdateHotkeys", function(self,actionButtonType)
                local id = self:GetID()
                self.bindingAction = "nUI_ActionBar_Button"..id;
                local key = GetBindingKey("CLICK "..self.bindingAction..":LeftButton")
                local hotkey = self.HotKey
                local text = GetBindingText(key, 1)
                if text then
                    hotkey:SetText(text)
                    hotkey:Show()
                end
            end)
            
            -- update the hotkeys
            button:UpdateHotkeys()
        end
    end)
end


-------------------------------------------------------------------------------
-- Event function
local function onEvent( who, event, arg1 )
	if event == "ADDON_LOADED" then		
		if arg1 == "nUI" then		
			nUI:registerScalableFrame( frame );
		end	
	end
end

frame:SetScript( "OnEvent", onEvent );
frame:RegisterEvent( "ADDON_LOADED" );

local defaultSkin = nUI_DefaultConfig.OverrideActionBar

-- NOTE: On skin addons this line needs to be added if the positioning needs adjusting
nUI_OverrideBarController:applySkin(defaultSkin)
